unit DtProp97;

(******************************************************************************
TDateProperty97

Derived from
    TPropertyEditor

Author name=BOURMAD Mehdi
Author E-mail=bourmad@multimania.com
Author URL=www.multimania.com/bourmad
******************************************************************************)

interface

uses
  WinProcs, Controls, Dialogs, DsgnIntf, Forms, SysUtils,
  DtCal97, DtEdit97, DtMisc97, DtPop97;

type
{*************** DateProperty97 Property Editor *******************}
  TDateProperty97 = class(TFloatProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
    procedure SetValue (const value: string); override;
    procedure Edit; override;
  end;

{*************** DateEditor97 Component Editor ********************}
  TDateEditor97 = class(TDefaultEditor)
  public
    procedure ExecuteVerb(Index : Integer); override;
    function GetVerb(Index : Integer): string; override;
    function GetVerbCount : Integer; override;
    procedure Edit; override;
  end;

implementation

function ShowDateEditor(Caption : String; aDate: tDateTime) : tDateTime;
var
  DateOrig : tDateTime;
  FrmCalendar : tDtCalPop97;
begin
  FrmCalendar := tDtCalPop97.Create (Application);
  FrmCalendar.BorderStyle := bsDialog;
  FrmCalendar.Caption := caption;

  DateOrig := aDate;
  if aDate=0
    then aDate := Now;
  FrmCalendar.Calendar97.Date := aDate;

  if FrmCalendar.ShowModal=mrOk
  then begin
    Result := FrmCalendar.Calendar97.Date;
  end
  else begin
    Result := DateOrig;
  end;
  FrmCalendar.Free;
end;

{********************* DateProperty97 Property Editor *************************}
function TDateProperty97.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog]
                                    - [paSubProperties];
end;

function TDateProperty97.GetValue: string;
var
  aDate : tDateTime;
begin
  aDate := GetFloatValue;
  if aDate<>0
    then Result := DateToStr(aDate)
    else Result := IdsValNone;
end;

procedure TDateProperty97.SetValue (const value: string);
begin
  try
    messagebeep(0);
    SetFloatValue(StrToDate(Value));
  except
    SetFloatValue (0);
  end;
end;

procedure TDateProperty97.Edit;
var
  aDate : tDateTime;
  aCaption : String;
begin
  aDate := GetFloatValue;

 {$IFNDEF WIN32}  {Delphi 1}
    aCaption := GetComponent(0).Name+'.'+GetName;
 {$ELSE}
   {$IFDEF VER90} {Delphi 2}
      aCaption := GetComponent(0).Name+'.'+GetName;
   {$ELSE}
     {$IFDEF VER93} {C++ Builder}
        aCaption := GetComponent(0).Name+'.'+GetName;
     {$ELSE}        {Delphi 3 and later (?)}
        aCaption := GetComponent(0).GetNamePath+'.'+GetName;
     {$ENDIF}
   {$ENDIF}
 {$ENDIF}

  SetFloatValue (ShowDateEditor (aCaption, aDate));
end;

{********************** DateEditor97 Component Editor *************************}
procedure TDateEditor97.ExecuteVerb(Index: Integer);
begin
  Case Index of
    0 : Edit;
  end;
end;

function TDateEditor97.GetVerb(Index: Integer): String;
begin
  Result := IdsDefaultDate;
end;

function TDateEditor97.GetVerbCount: Integer;
begin
  Result := 1;
end;

procedure TDateEditor97.Edit;
var
  aCaption : String;
  aDate : tDateTime;
begin
  if Component is TDateEdit97
  then begin
    aDate := TDateEdit97(Component).Date;
    aCaption := Component.Name;
    TDateEdit97(Component).Date := ShowDateEditor (aCaption, aDate);
  end;
  if Component is TCalendar97
  then begin
    aDate := TCalendar97(Component).Date;
    aCaption := Component.Name;
    TCalendar97(Component).Date := ShowDateEditor (aCaption, aDate);
  end;
end;

end.

